/* argument.c generated by valac 0.56.17, the Vala compiler
 * generated from argument.vala, do not modify */

/*
 * -- Mickey's DBus Utility V2 --
 *
 * Copyright (C) 2009-2012 Michael 'Mickey' Lauer <mlauer@vanille-media.de>
 *                         Frederik 'playya' Sdun <frederik.sdun@googlemail.com>
 *                         Simon Busch <morphis@gravedo.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <float.h>
#include <math.h>
#include <stdio.h>

#define ARGUMENT_arg_separator ','
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif
#if !defined(VALA_EXTERN)
#if defined(_MSC_VER)
#define VALA_EXTERN __declspec(dllexport) extern
#elif __GNUC__ >= 4
#define VALA_EXTERN __attribute__((visibility("default"))) extern
#else
#define VALA_EXTERN extern
#endif
#endif

#define TYPE_ARGUMENT (argument_get_type ())
#define ARGUMENT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_ARGUMENT, Argument))
#define ARGUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_ARGUMENT, ArgumentClass))
#define IS_ARGUMENT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_ARGUMENT))
#define IS_ARGUMENT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_ARGUMENT))
#define ARGUMENT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_ARGUMENT, ArgumentClass))

typedef struct _Argument Argument;
typedef struct _ArgumentClass ArgumentClass;
typedef struct _ArgumentPrivate ArgumentPrivate;
enum  {
	ARGUMENT_0_PROPERTY,
	ARGUMENT_NUM_PROPERTIES
};
static GParamSpec* argument_properties[ARGUMENT_NUM_PROPERTIES];
#define _g_variant_builder_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_builder_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Argument {
	GObject parent_instance;
	ArgumentPrivate * priv;
	gchar* name;
	gchar* type;
};

struct _ArgumentClass {
	GObjectClass parent_class;
};

struct _ArgumentPrivate {
	GVariantBuilder* _vbuilder;
};

static gint Argument_private_offset;
static gpointer argument_parent_class = NULL;

VALA_EXTERN GType argument_get_type (void) G_GNUC_CONST ;
G_DEFINE_AUTOPTR_CLEANUP_FUNC (Argument, g_object_unref)
VALA_EXTERN Argument* argument_new (const gchar* name,
                        const gchar* type,
                        GVariantBuilder* vbuilder);
VALA_EXTERN Argument* argument_construct (GType object_type,
                              const gchar* name,
                              const gchar* type,
                              GVariantBuilder* vbuilder);
VALA_EXTERN gboolean argument_append (Argument* self,
                          const gchar* arg);
static gboolean argument_append_type (Argument* self,
                               const gchar* arg,
                               const gchar* type,
                               GVariantBuilder* vbuilder);
static gchar* argument_get_sub_signature (Argument* self,
                                   const gchar* signature);
static gboolean argument_append_array_type (Argument* self,
                                     const gchar* arg,
                                     const gchar* type,
                                     GVariantBuilder* vbuilder);
static gboolean argument_append_struct_type (Argument* self,
                                      const gchar* arg,
                                      const gchar* type,
                                      GVariantBuilder* vbuilder);
VALA_EXTERN gboolean argument_append_dict_entry_type (Argument* self,
                                          const gchar* arg,
                                          const gchar* type,
                                          GVariantBuilder* vbuilder);
static gchar** argument_get_sub_args (Argument* self,
                               const gchar* arg,
                               gchar separator,
                               gint* result_length1);
static gboolean _vala_char_array_contains (gchar * stack,
                                    gssize stack_length,
                                    const gchar needle);
static void _vala_array_add8 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void _vala_array_add9 (gchar** * array,
                       gint* length,
                       gint* size,
                       gchar* value);
static void argument_finalize (GObject * obj);
static GType argument_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const gchar ARGUMENT_start_chars[3] = {'{', '[', '('};
static const gchar ARGUMENT_end_chars[3] = {'}', ']', ')'};

static inline gpointer
argument_get_instance_private (Argument* self)
{
	return G_STRUCT_MEMBER_P (self, Argument_private_offset);
}

static gpointer
_g_variant_builder_ref0 (gpointer self)
{
	return self ? g_variant_builder_ref (self) : NULL;
}

Argument*
argument_construct (GType object_type,
                    const gchar* name,
                    const gchar* type,
                    GVariantBuilder* vbuilder)
{
	Argument * self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GVariantBuilder* _tmp2_;
	g_return_val_if_fail (name != NULL, NULL);
	g_return_val_if_fail (type != NULL, NULL);
	g_return_val_if_fail (vbuilder != NULL, NULL);
	self = (Argument*) g_object_new (object_type, NULL);
	_tmp0_ = g_strdup (name);
	_g_free0 (self->name);
	self->name = _tmp0_;
	_tmp1_ = g_strdup (type);
	_g_free0 (self->type);
	self->type = _tmp1_;
	_tmp2_ = _g_variant_builder_ref0 (vbuilder);
	_g_variant_builder_unref0 (self->priv->_vbuilder);
	self->priv->_vbuilder = _tmp2_;
	return self;
}

Argument*
argument_new (const gchar* name,
              const gchar* type,
              GVariantBuilder* vbuilder)
{
	return argument_construct (TYPE_ARGUMENT, name, type, vbuilder);
}

gboolean
argument_append (Argument* self,
                 const gchar* arg)
{
	const gchar* _tmp0_;
	GVariantBuilder* _tmp1_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (arg != NULL, FALSE);
	_tmp0_ = self->type;
	_tmp1_ = self->priv->_vbuilder;
	result = argument_append_type (self, arg, _tmp0_, _tmp1_);
	return result;
}

static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	glong result;
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
	end = _tmp0_;
	_tmp1_ = end;
	if (_tmp1_ == NULL) {
		result = maxlen;
		return result;
	} else {
		gchar* _tmp2_;
		_tmp2_ = end;
		result = (glong) (_tmp2_ - str);
		return result;
	}
}

static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	gchar* _tmp3_;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	if (offset >= ((glong) 0)) {
		_tmp0_ = len >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		string_length = string_strnlen ((gchar*) self, offset + len);
	} else {
		gint _tmp1_;
		gint _tmp2_;
		_tmp1_ = strlen (self);
		_tmp2_ = _tmp1_;
		string_length = (glong) _tmp2_;
	}
	if (offset < ((glong) 0)) {
		offset = string_length + offset;
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
	} else {
		g_return_val_if_fail (offset <= string_length, NULL);
	}
	if (len < ((glong) 0)) {
		len = string_length - offset;
	}
	g_return_val_if_fail ((offset + len) <= string_length, NULL);
	_tmp3_ = g_strndup (((gchar*) self) + offset, (gsize) len);
	result = _tmp3_;
	return result;
}

static glong
long_parse (const gchar* str,
            guint _base)
{
	glong result;
	g_return_val_if_fail (str != NULL, 0L);
	result = strtol (str, NULL, (gint) _base);
	return result;
}

static gdouble
double_parse (const gchar* str)
{
	gdouble result;
	g_return_val_if_fail (str != NULL, 0.0);
	result = g_ascii_strtod (str, NULL);
	return result;
}

static const gchar*
string_to_string (const gchar* self)
{
	const gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	result = self;
	return result;
}

static gboolean
argument_append_type (Argument* self,
                      const gchar* arg,
                      const gchar* type,
                      GVariantBuilder* vbuilder)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
	static GQuark _tmp2_label0 = 0;
	static GQuark _tmp2_label1 = 0;
	static GQuark _tmp2_label2 = 0;
	static GQuark _tmp2_label3 = 0;
	static GQuark _tmp2_label4 = 0;
	static GQuark _tmp2_label5 = 0;
	static GQuark _tmp2_label6 = 0;
	static GQuark _tmp2_label7 = 0;
	static GQuark _tmp2_label8 = 0;
	static GQuark _tmp2_label9 = 0;
	static GQuark _tmp2_label10 = 0;
	static GQuark _tmp2_label11 = 0;
	static GQuark _tmp2_label12 = 0;
	static GQuark _tmp2_label13 = 0;
	static GQuark _tmp2_label14 = 0;
	GError* _inner_error0_ = NULL;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (arg != NULL, FALSE);
	g_return_val_if_fail (type != NULL, FALSE);
	g_return_val_if_fail (vbuilder != NULL, FALSE);
	_tmp0_ = string_substring (type, (glong) 0, (glong) 1);
	_tmp1_ = _tmp0_;
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
	g_free (_tmp1_);
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("v")))) {
		switch (0) {
			default:
			{
				GVariant* _tmp4_;
				GVariant* _tmp5_;
				GVariant* _tmp6_;
				GVariant* _tmp7_;
				_tmp4_ = g_variant_new_parsed (arg, NULL);
				g_variant_ref_sink (_tmp4_);
				_tmp5_ = _tmp4_;
				_tmp6_ = g_variant_new_variant (_tmp5_);
				g_variant_ref_sink (_tmp6_);
				_tmp7_ = _tmp6_;
				g_variant_builder_add_value (vbuilder, _tmp7_);
				_g_variant_unref0 (_tmp7_);
				_g_variant_unref0 (_tmp5_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("y")))) {
		switch (0) {
			default:
			{
				guint8 value = 0U;
				GVariant* _tmp8_;
				GVariant* _tmp9_;
				value = (guint8) atoi (arg);
				_tmp8_ = g_variant_new_byte (value);
				g_variant_ref_sink (_tmp8_);
				_tmp9_ = _tmp8_;
				g_variant_builder_add_value (vbuilder, _tmp9_);
				_g_variant_unref0 (_tmp9_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("b")))) {
		switch (0) {
			default:
			{
				gboolean _tmp10_ = FALSE;
				gboolean _tmp11_ = FALSE;
				gboolean value = FALSE;
				GVariant* _tmp12_;
				GVariant* _tmp13_;
				if (g_strcmp0 (arg, "true") == 0) {
					_tmp11_ = TRUE;
				} else {
					_tmp11_ = g_strcmp0 (arg, "True") == 0;
				}
				if (_tmp11_) {
					_tmp10_ = TRUE;
				} else {
					_tmp10_ = g_strcmp0 (arg, "1") == 0;
				}
				value = _tmp10_;
				_tmp12_ = g_variant_new_boolean (value);
				g_variant_ref_sink (_tmp12_);
				_tmp13_ = _tmp12_;
				g_variant_builder_add_value (vbuilder, _tmp13_);
				_g_variant_unref0 (_tmp13_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("n")))) {
		switch (0) {
			default:
			{
				gint16 value = 0;
				GVariant* _tmp14_;
				GVariant* _tmp15_;
				value = (gint16) atoi (arg);
				_tmp14_ = g_variant_new_int16 (value);
				g_variant_ref_sink (_tmp14_);
				_tmp15_ = _tmp14_;
				g_variant_builder_add_value (vbuilder, _tmp15_);
				_g_variant_unref0 (_tmp15_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("i")))) {
		switch (0) {
			default:
			{
				gint32 value = 0;
				GVariant* _tmp16_;
				GVariant* _tmp17_;
				value = (gint32) atoi (arg);
				_tmp16_ = g_variant_new_int32 (value);
				g_variant_ref_sink (_tmp16_);
				_tmp17_ = _tmp16_;
				g_variant_builder_add_value (vbuilder, _tmp17_);
				_g_variant_unref0 (_tmp17_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("q")))) {
		switch (0) {
			default:
			{
				guint16 value = 0U;
				GVariant* _tmp18_;
				GVariant* _tmp19_;
				value = (guint16) atoi (arg);
				_tmp18_ = g_variant_new_uint16 (value);
				g_variant_ref_sink (_tmp18_);
				_tmp19_ = _tmp18_;
				g_variant_builder_add_value (vbuilder, _tmp19_);
				_g_variant_unref0 (_tmp19_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("u")))) {
		switch (0) {
			default:
			{
				guint32 value = 0U;
				GVariant* _tmp20_;
				GVariant* _tmp21_;
				value = (guint32) long_parse (arg, (guint) 0);
				_tmp20_ = g_variant_new_uint32 (value);
				g_variant_ref_sink (_tmp20_);
				_tmp21_ = _tmp20_;
				g_variant_builder_add_value (vbuilder, _tmp21_);
				_g_variant_unref0 (_tmp21_);
				break;
			}
		}
	} else if ((_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("t")))) || (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("x"))))) {
		switch (0) {
			default:
			{
				guint64 value = 0ULL;
				GVariant* _tmp22_;
				GVariant* _tmp23_;
				value = (guint64) long_parse (arg, (guint) 0);
				_tmp22_ = g_variant_new_uint64 (value);
				g_variant_ref_sink (_tmp22_);
				_tmp23_ = _tmp22_;
				g_variant_builder_add_value (vbuilder, _tmp23_);
				_g_variant_unref0 (_tmp23_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("d")))) {
		switch (0) {
			default:
			{
				gdouble value = 0.0;
				GVariant* _tmp24_;
				GVariant* _tmp25_;
				value = double_parse (arg);
				_tmp24_ = g_variant_new_double (value);
				g_variant_ref_sink (_tmp24_);
				_tmp25_ = _tmp24_;
				g_variant_builder_add_value (vbuilder, _tmp25_);
				_g_variant_unref0 (_tmp25_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("s")))) {
		switch (0) {
			default:
			{
				{
					GVariant* v = NULL;
					const GVariantType* _tmp26_;
					GVariant* _tmp27_;
					GVariant* _tmp28_;
					_tmp26_ = G_VARIANT_TYPE_STRING;
					_tmp27_ = g_variant_parse (_tmp26_, arg, NULL, NULL, &_inner_error0_);
					v = _tmp27_;
					if (G_UNLIKELY (_inner_error0_ != NULL)) {
						goto __catch0_g_error;
					}
					_tmp28_ = v;
					g_variant_builder_add_value (vbuilder, _tmp28_);
					_g_variant_unref0 (v);
				}
				goto __finally0;
				__catch0_g_error:
				{
					GVariant* _tmp29_;
					GVariant* _tmp30_;
					g_clear_error (&_inner_error0_);
					_tmp29_ = g_variant_new_string (arg);
					g_variant_ref_sink (_tmp29_);
					_tmp30_ = _tmp29_;
					g_variant_builder_add_value (vbuilder, _tmp30_);
					_g_variant_unref0 (_tmp30_);
				}
				__finally0:
				if (G_UNLIKELY (_inner_error0_ != NULL)) {
					gboolean _tmp31_ = FALSE;
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
					g_clear_error (&_inner_error0_);
					return _tmp31_;
				}
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("o")))) {
		switch (0) {
			default:
			{
				GVariant* _tmp32_;
				GVariant* _tmp33_;
				_tmp32_ = g_variant_new_object_path (arg);
				g_variant_ref_sink (_tmp32_);
				_tmp33_ = _tmp32_;
				g_variant_builder_add_value (vbuilder, _tmp33_);
				_g_variant_unref0 (_tmp33_);
				break;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("a")))) {
		switch (0) {
			default:
			{
				gchar* subsig = NULL;
				gint _tmp34_;
				gint _tmp35_;
				gchar* _tmp36_;
				gchar* _tmp37_;
				gchar* _tmp38_;
				gchar* _tmp39_;
				const gchar* _tmp40_;
				_tmp34_ = strlen (type);
				_tmp35_ = _tmp34_;
				_tmp36_ = string_substring (type, (glong) 1, (glong) (_tmp35_ - 1));
				_tmp37_ = _tmp36_;
				_tmp38_ = argument_get_sub_signature (self, _tmp37_);
				_tmp39_ = _tmp38_;
				_g_free0 (_tmp37_);
				subsig = _tmp39_;
				_tmp40_ = subsig;
				result = argument_append_array_type (self, arg, _tmp40_, vbuilder);
				_g_free0 (subsig);
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label13) ? _tmp2_label13 : (_tmp2_label13 = g_quark_from_static_string ("(")))) {
		switch (0) {
			default:
			{
				result = argument_append_struct_type (self, arg, type, vbuilder);
				return result;
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label14) ? _tmp2_label14 : (_tmp2_label14 = g_quark_from_static_string ("{")))) {
		switch (0) {
			default:
			{
				result = argument_append_dict_entry_type (self, arg, type, vbuilder);
				return result;
			}
		}
	} else {
		switch (0) {
			default:
			{
				FILE* _tmp41_;
				const gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				_tmp41_ = stderr;
				_tmp42_ = string_to_string (type);
				_tmp43_ = g_strconcat ("Unsupported type ", _tmp42_, "\n", NULL);
				_tmp44_ = _tmp43_;
				fprintf (_tmp41_, "%s", _tmp44_);
				_g_free0 (_tmp44_);
				result = FALSE;
				return result;
			}
		}
	}
	result = TRUE;
	return result;
}

static gboolean
argument_append_array_type (Argument* self,
                            const gchar* arg,
                            const gchar* type,
                            GVariantBuilder* vbuilder)
{
	GVariantBuilder* va = NULL;
	const GVariantType* _tmp0_;
	GVariantBuilder* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gint _tmp6_ = 0;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	GVariantBuilder* _tmp12_;
	GVariant* _tmp13_;
	GVariant* _tmp14_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (arg != NULL, FALSE);
	g_return_val_if_fail (type != NULL, FALSE);
	g_return_val_if_fail (vbuilder != NULL, FALSE);
	_tmp0_ = G_VARIANT_TYPE_ARRAY;
	_tmp1_ = g_variant_builder_new (_tmp0_);
	va = _tmp1_;
	_tmp2_ = strlen (arg);
	_tmp3_ = _tmp2_;
	_tmp4_ = string_substring (arg, (glong) 1, (glong) (_tmp3_ - 2));
	_tmp5_ = _tmp4_;
	_tmp7_ = argument_get_sub_args (self, _tmp5_, ARGUMENT_arg_separator, &_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp8__length1 = _tmp6_;
	_g_free0 (_tmp5_);
	{
		gchar** sub_arg_collection = NULL;
		gint sub_arg_collection_length1 = 0;
		gint _sub_arg_collection_size_ = 0;
		gint sub_arg_it = 0;
		sub_arg_collection = _tmp8_;
		sub_arg_collection_length1 = _tmp8__length1;
		for (sub_arg_it = 0; sub_arg_it < sub_arg_collection_length1; sub_arg_it = sub_arg_it + 1) {
			gchar* _tmp9_;
			gchar* sub_arg = NULL;
			_tmp9_ = g_strdup (sub_arg_collection[sub_arg_it]);
			sub_arg = _tmp9_;
			{
				const gchar* _tmp10_;
				GVariantBuilder* _tmp11_;
				_tmp10_ = sub_arg;
				_tmp11_ = va;
				if (argument_append_type (self, _tmp10_, type, _tmp11_) == FALSE) {
					result = FALSE;
					_g_free0 (sub_arg);
					sub_arg_collection = (_vala_array_free (sub_arg_collection, sub_arg_collection_length1, (GDestroyNotify) g_free), NULL);
					_g_variant_builder_unref0 (va);
					return result;
				}
				_g_free0 (sub_arg);
			}
		}
		sub_arg_collection = (_vala_array_free (sub_arg_collection, sub_arg_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	_tmp12_ = va;
	_tmp13_ = g_variant_builder_end (_tmp12_);
	g_variant_ref_sink (_tmp13_);
	_tmp14_ = _tmp13_;
	g_variant_builder_add_value (vbuilder, _tmp14_);
	_g_variant_unref0 (_tmp14_);
	result = TRUE;
	_g_variant_builder_unref0 (va);
	return result;
}

static gboolean
argument_append_struct_type (Argument* self,
                             const gchar* arg,
                             const gchar* type,
                             GVariantBuilder* vbuilder)
{
	gint sigpos = 0;
	gchar* subtype = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_ = 0;
	gchar** _tmp8_;
	gchar** _tmp9_;
	gint _tmp9__length1;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (arg != NULL, FALSE);
	g_return_val_if_fail (type != NULL, FALSE);
	g_return_val_if_fail (vbuilder != NULL, FALSE);
	sigpos = 0;
	_tmp0_ = strlen (type);
	_tmp1_ = _tmp0_;
	_tmp2_ = string_substring (type, (glong) 1, (glong) (_tmp1_ - 2));
	subtype = _tmp2_;
	_tmp3_ = strlen (arg);
	_tmp4_ = _tmp3_;
	_tmp5_ = string_substring (arg, (glong) 1, (glong) (_tmp4_ - 2));
	_tmp6_ = _tmp5_;
	_tmp8_ = argument_get_sub_args (self, _tmp6_, ARGUMENT_arg_separator, &_tmp7_);
	_tmp9_ = _tmp8_;
	_tmp9__length1 = _tmp7_;
	_g_free0 (_tmp6_);
	{
		gchar** s_collection = NULL;
		gint s_collection_length1 = 0;
		gint _s_collection_size_ = 0;
		gint s_it = 0;
		s_collection = _tmp9_;
		s_collection_length1 = _tmp9__length1;
		for (s_it = 0; s_it < s_collection_length1; s_it = s_it + 1) {
			gchar* _tmp10_;
			gchar* s = NULL;
			_tmp10_ = g_strdup (s_collection[s_it]);
			s = _tmp10_;
			{
				gchar* sig = NULL;
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				gchar* _tmp15_;
				const gchar* _tmp16_;
				gint _tmp17_;
				gint _tmp18_;
				const gchar* _tmp19_;
				const gchar* _tmp20_;
				_tmp11_ = subtype;
				_tmp12_ = string_substring (_tmp11_, (glong) sigpos, (glong) -1);
				_tmp13_ = _tmp12_;
				_tmp14_ = argument_get_sub_signature (self, _tmp13_);
				_tmp15_ = _tmp14_;
				_g_free0 (_tmp13_);
				sig = _tmp15_;
				_tmp16_ = sig;
				_tmp17_ = strlen (_tmp16_);
				_tmp18_ = _tmp17_;
				sigpos += (gint) _tmp18_;
				_tmp19_ = s;
				_tmp20_ = sig;
				if (argument_append_type (self, _tmp19_, _tmp20_, vbuilder) == FALSE) {
					result = FALSE;
					_g_free0 (sig);
					_g_free0 (s);
					s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
					_g_free0 (subtype);
					return result;
				}
				_g_free0 (sig);
				_g_free0 (s);
			}
		}
		s_collection = (_vala_array_free (s_collection, s_collection_length1, (GDestroyNotify) g_free), NULL);
	}
	result = TRUE;
	_g_free0 (subtype);
	return result;
}

gboolean
argument_append_dict_entry_type (Argument* self,
                                 const gchar* arg,
                                 const gchar* type,
                                 GVariantBuilder* vbuilder)
{
	gchar* subtype = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* keytype = NULL;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* valuetype = NULL;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gchar* _tmp9_;
	gchar** values = NULL;
	gint _tmp10_ = 0;
	gchar** _tmp11_;
	gint values_length1;
	gint _values_size_;
	gchar* key = NULL;
	gchar** _tmp12_;
	gint _tmp12__length1;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* value = NULL;
	gchar** _tmp15_;
	gint _tmp15__length1;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	GVariantBuilder* vde = NULL;
	const GVariantType* _tmp18_;
	GVariantBuilder* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GVariantBuilder* _tmp22_;
	const gchar* _tmp23_;
	const gchar* _tmp24_;
	GVariantBuilder* _tmp25_;
	GVariantBuilder* _tmp26_;
	GVariant* _tmp27_;
	GVariant* _tmp28_;
	gboolean result;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (arg != NULL, FALSE);
	g_return_val_if_fail (type != NULL, FALSE);
	g_return_val_if_fail (vbuilder != NULL, FALSE);
	_tmp0_ = strlen (type);
	_tmp1_ = _tmp0_;
	_tmp2_ = string_substring (type, (glong) 1, (glong) (_tmp1_ - 2));
	subtype = _tmp2_;
	_tmp3_ = subtype;
	_tmp4_ = argument_get_sub_signature (self, _tmp3_);
	keytype = _tmp4_;
	_tmp5_ = subtype;
	_tmp6_ = keytype;
	_tmp7_ = strlen (_tmp6_);
	_tmp8_ = _tmp7_;
	_tmp9_ = string_substring (_tmp5_, (glong) _tmp8_, (glong) -1);
	valuetype = _tmp9_;
	_tmp11_ = argument_get_sub_args (self, arg, ':', &_tmp10_);
	values = _tmp11_;
	values_length1 = _tmp10_;
	_values_size_ = values_length1;
	_tmp12_ = values;
	_tmp12__length1 = values_length1;
	_tmp13_ = _tmp12_[0];
	_tmp14_ = g_strdup (_tmp13_);
	key = _tmp14_;
	_tmp15_ = values;
	_tmp15__length1 = values_length1;
	_tmp16_ = _tmp15_[1];
	_tmp17_ = g_strdup (_tmp16_);
	value = _tmp17_;
	_tmp18_ = G_VARIANT_TYPE_DICT_ENTRY;
	_tmp19_ = g_variant_builder_new (_tmp18_);
	vde = _tmp19_;
	_tmp20_ = key;
	_tmp21_ = keytype;
	_tmp22_ = vde;
	if (argument_append_type (self, _tmp20_, _tmp21_, _tmp22_) == FALSE) {
		result = FALSE;
		_g_variant_builder_unref0 (vde);
		_g_free0 (value);
		_g_free0 (key);
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (valuetype);
		_g_free0 (keytype);
		_g_free0 (subtype);
		return result;
	}
	_tmp23_ = value;
	_tmp24_ = valuetype;
	_tmp25_ = vde;
	if (argument_append_type (self, _tmp23_, _tmp24_, _tmp25_) == FALSE) {
		result = FALSE;
		_g_variant_builder_unref0 (vde);
		_g_free0 (value);
		_g_free0 (key);
		values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
		_g_free0 (valuetype);
		_g_free0 (keytype);
		_g_free0 (subtype);
		return result;
	}
	_tmp26_ = vde;
	_tmp27_ = g_variant_builder_end (_tmp26_);
	g_variant_ref_sink (_tmp27_);
	_tmp28_ = _tmp27_;
	g_variant_builder_add_value (vbuilder, _tmp28_);
	_g_variant_unref0 (_tmp28_);
	result = TRUE;
	_g_variant_builder_unref0 (vde);
	_g_free0 (value);
	_g_free0 (key);
	values = (_vala_array_free (values, values_length1, (GDestroyNotify) g_free), NULL);
	_g_free0 (valuetype);
	_g_free0 (keytype);
	_g_free0 (subtype);
	return result;
}

static gchar
string_get (const gchar* self,
            glong index)
{
	gchar _tmp0_;
	gchar result;
	g_return_val_if_fail (self != NULL, '\0');
	_tmp0_ = ((gchar*) self)[index];
	result = _tmp0_;
	return result;
}

static gboolean
_vala_char_array_contains (gchar * stack,
                           gssize stack_length,
                           const gchar needle)
{
	gssize i;
	for (i = 0; i < stack_length; i++) {
		if (needle == stack[i]) {
			return TRUE;
		}
	}
	return FALSE;
}

static gchar*
argument_get_sub_signature (Argument* self,
                            const gchar* signature)
{
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gint depth = 0;
	gchar* result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (signature != NULL, NULL);
	_tmp0_ = g_strdup ("");
	_result_ = _tmp0_;
	depth = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				gint _tmp3_;
				gint _tmp4_;
				gchar c = '\0';
				const gchar* _tmp11_;
				gchar* _tmp12_;
				gchar* _tmp13_;
				gchar* _tmp14_;
				if (!_tmp1_) {
					gint _tmp2_;
					_tmp2_ = i;
					i = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = strlen (signature);
				_tmp4_ = _tmp3_;
				if (!(i < _tmp4_)) {
					break;
				}
				c = (gchar) string_get (signature, (glong) i);
				if (c == 'a') {
					const gchar* _tmp5_;
					gchar* _tmp6_;
					gchar* _tmp7_;
					gchar* _tmp8_;
					_tmp5_ = _result_;
					_tmp6_ = g_strdup_printf ("%c", c);
					_tmp7_ = _tmp6_;
					_tmp8_ = g_strconcat (_tmp5_, _tmp7_, NULL);
					_g_free0 (_result_);
					_result_ = _tmp8_;
					_g_free0 (_tmp7_);
					continue;
				} else {
					if (_vala_char_array_contains (ARGUMENT_start_chars, G_N_ELEMENTS (ARGUMENT_start_chars), c)) {
						gint _tmp9_;
						_tmp9_ = depth;
						depth = _tmp9_ + 1;
					} else {
						if (_vala_char_array_contains (ARGUMENT_end_chars, G_N_ELEMENTS (ARGUMENT_end_chars), c)) {
							gint _tmp10_;
							_tmp10_ = depth;
							depth = _tmp10_ - 1;
						}
					}
				}
				_tmp11_ = _result_;
				_tmp12_ = g_strdup_printf ("%c", c);
				_tmp13_ = _tmp12_;
				_tmp14_ = g_strconcat (_tmp11_, _tmp13_, NULL);
				_g_free0 (_result_);
				_result_ = _tmp14_;
				_g_free0 (_tmp13_);
				if (depth == 0) {
					break;
				}
			}
		}
	}
	_vala_assert (depth == 0, "depth == 0");
	result = _result_;
	return result;
}

static void
_vala_array_add8 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static void
_vala_array_add9 (gchar** * array,
                  gint* length,
                  gint* size,
                  gchar* value)
{
	if ((*length) == (*size)) {
		*size = (*size) ? (2 * (*size)) : 4;
		*array = g_renew (gchar*, *array, (*size) + 1);
	}
	(*array)[(*length)++] = value;
	(*array)[*length] = NULL;
}

static gchar**
argument_get_sub_args (Argument* self,
                       const gchar* arg,
                       gchar separator,
                       gint* result_length1)
{
	gchar** _result_ = NULL;
	gchar** _tmp0_;
	gint _result__length1;
	gint __result__size_;
	gchar* part = NULL;
	gchar* _tmp1_;
	gint depth = 0;
	const gchar* _tmp19_;
	gint _tmp20_;
	gint _tmp21_;
	gchar** _tmp24_;
	gint _tmp24__length1;
	gchar** result;
	g_return_val_if_fail (self != NULL, NULL);
	g_return_val_if_fail (arg != NULL, NULL);
	_tmp0_ = g_new0 (gchar*, 0 + 1);
	_result_ = _tmp0_;
	_result__length1 = 0;
	__result__size_ = _result__length1;
	_tmp1_ = g_strdup ("");
	part = _tmp1_;
	depth = 0;
	{
		gint i = 0;
		i = 0;
		{
			gboolean _tmp2_ = FALSE;
			_tmp2_ = TRUE;
			while (TRUE) {
				gint _tmp4_;
				gint _tmp5_;
				gchar c = '\0';
				const gchar* _tmp8_;
				gchar* _tmp9_;
				gchar* _tmp10_;
				gchar* _tmp11_;
				gboolean _tmp12_ = FALSE;
				if (!_tmp2_) {
					gint _tmp3_;
					_tmp3_ = i;
					i = _tmp3_ + 1;
				}
				_tmp2_ = FALSE;
				_tmp4_ = strlen (arg);
				_tmp5_ = _tmp4_;
				if (!(i < _tmp5_)) {
					break;
				}
				c = (gchar) string_get (arg, (glong) i);
				if (_vala_char_array_contains (ARGUMENT_start_chars, G_N_ELEMENTS (ARGUMENT_start_chars), c)) {
					gint _tmp6_;
					_tmp6_ = depth;
					depth = _tmp6_ + 1;
				} else {
					if (_vala_char_array_contains (ARGUMENT_end_chars, G_N_ELEMENTS (ARGUMENT_end_chars), c)) {
						gint _tmp7_;
						_tmp7_ = depth;
						depth = _tmp7_ - 1;
					}
				}
				_tmp8_ = part;
				_tmp9_ = g_strdup_printf ("%c", c);
				_tmp10_ = _tmp9_;
				_tmp11_ = g_strconcat (_tmp8_, _tmp10_, NULL);
				_g_free0 (part);
				part = _tmp11_;
				_g_free0 (_tmp10_);
				if (depth == 0) {
					_tmp12_ = c == separator;
				} else {
					_tmp12_ = FALSE;
				}
				if (_tmp12_) {
					const gchar* _tmp13_;
					const gchar* _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
					gchar* _tmp17_;
					gchar* _tmp18_;
					_tmp13_ = part;
					_tmp14_ = part;
					_tmp15_ = strlen (_tmp14_);
					_tmp16_ = _tmp15_;
					_tmp17_ = string_substring (_tmp13_, (glong) 0, (glong) (_tmp16_ - 1));
					_vala_array_add8 (&_result_, &_result__length1, &__result__size_, _tmp17_);
					_tmp18_ = g_strdup ("");
					_g_free0 (part);
					part = _tmp18_;
				}
			}
		}
	}
	_vala_assert (depth == 0, "depth == 0");
	_tmp19_ = part;
	_tmp20_ = strlen (_tmp19_);
	_tmp21_ = _tmp20_;
	if (_tmp21_ != 0) {
		const gchar* _tmp22_;
		gchar* _tmp23_;
		_tmp22_ = part;
		_tmp23_ = g_strdup (_tmp22_);
		_vala_array_add9 (&_result_, &_result__length1, &__result__size_, _tmp23_);
	}
	_tmp24_ = _result_;
	_tmp24__length1 = _result__length1;
	if (result_length1) {
		*result_length1 = _tmp24__length1;
	}
	result = _tmp24_;
	_g_free0 (part);
	return result;
}

static void
argument_class_init (ArgumentClass * klass,
                     gpointer klass_data)
{
	argument_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &Argument_private_offset);
	G_OBJECT_CLASS (klass)->finalize = argument_finalize;
}

static void
argument_instance_init (Argument * self,
                        gpointer klass)
{
	self->priv = argument_get_instance_private (self);
}

static void
argument_finalize (GObject * obj)
{
	Argument * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_ARGUMENT, Argument);
	_g_variant_builder_unref0 (self->priv->_vbuilder);
	_g_free0 (self->name);
	_g_free0 (self->type);
	G_OBJECT_CLASS (argument_parent_class)->finalize (obj);
}

static GType
argument_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (ArgumentClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) argument_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Argument), 0, (GInstanceInitFunc) argument_instance_init, NULL };
	GType argument_type_id;
	argument_type_id = g_type_register_static (G_TYPE_OBJECT, "Argument", &g_define_type_info, 0);
	Argument_private_offset = g_type_add_instance_private (argument_type_id, sizeof (ArgumentPrivate));
	return argument_type_id;
}

GType
argument_get_type (void)
{
	static volatile gsize argument_type_id__once = 0;
	if (g_once_init_enter (&argument_type_id__once)) {
		GType argument_type_id;
		argument_type_id = argument_get_type_once ();
		g_once_init_leave (&argument_type_id__once, argument_type_id);
	}
	return argument_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		gssize i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

